# Kumeru

[![CI](https://github.com/UltiRequiem/kumeru/actions/workflows/ci.yaml/badge.svg)](https://github.com/UltiRequiem/kumeru/actions/workflows/ci.yaml)
[![codecov](https://codecov.io/gh/ultirequiem/kumeru/branch/main/graph/badge.svg)](https://codecov.io/gh/ultirequiem/kumeru)
[![deno doc](https://doc.deno.land/badge.svg)](https://doc.deno.land/https/deno.land/x/kumeru/mod.ts)

![Custom badge](https://img.shields.io/endpoint?url=https%3A%2F%2Fdeno-visualizer.danopia.net%2Fshields%2Fdep-count%2Fx%2Fkumeru%2Fmod.ts)
![Custom badge](https://img.shields.io/endpoint?url=https%3A%2F%2Fdeno-visualizer.danopia.net%2Fshields%2Fupdates%2Fx%2Fkumeru%2Fmod.ts)
[![Custom badge](https://img.shields.io/endpoint?url=https%3A%2F%2Fdeno-visualizer.danopia.net%2Fshields%2Flatest-version%2Fx%2Fkumeru%2Fmod.ts)](https://doc.deno.land/https/deno.land/x/kumeru/mod.ts)

A low-level and HyperScript-like Frontend Library 🚀

There is still a lot to do, but you can use it already! Check
[Pages using Kumeru on Production](#pages-using-kumeru-on-production)!

## Usage

### [Deno 🦕](https://deno.land/x/kumeru)

```javascript
import {
  createElement,
  render,
  wrapElements,
} from "https://deno.land/x/kumeru/mod.ts";

const app = wrapElements(
  createElement("h1", "Kumeru"),
  createElement("a", "Documentation", {
    attributes: {
      href: "https://kumeru.js.org",
      target: "_blank",
    },
  }),
);

render(document.getElementById("root"), app);
```

### [Node.js 🐢](https://www.npmjs.com/package/kumeru)

```javascript
import { createElement, render } from "kumeru";

render(document.getElementById("root"), createElement("p", "Hello World"));
```

### Browser

Using
[type module](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Guide/Modules)
🍱

- [esm.sh](https://esm.sh/@ultirequiem/kumeru)

- [skypack](https://cdn.skypack.dev/@ultirequiem/kumeru)

Using a plain
[script tag](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/script) 👇

- [jsdelivr](https://cdn.jsdelivr.net/npm/@ultirequiem/kumeru)

- [unpkg](https://unpkg.com/@ultirequiem/kumeru)

You have the same API on all of this platforms.

## Docs

[Autogenerated Documentation](https://doc.deno.land/https://deno.land/x/kumeru/mod.ts)
😎

For examples you can check [`examples/`](./examples) 📂

## Support

Open an Issue, I will check it a soon as possible 👀

If you want to hurry me up a bit
[send me a tweet](https://twitter.com/intent/tweet?text=%40UltiRequiem%20) 😆

Consider [supporting me on Patreon](https://patreon.com/UltiRequiem) if you like
my work 🚀

Don't forget to start the repo ⭐

## Pages Using Kumeru on Production

Are you using Kumeru on your page? Make a pull request adding your page here!

- [Sergif](https://sergif.ultirequiem.com) - (Kumeru + Tailwind CSS + Netlify
  Functions)

## Licence

Licensed under the MIT Licence.
